import java.io.*;
import java.util.*;
import java.text.*;
import java_cup.runtime.Symbol;

class Game {
    String event;
    String site;
    String date;
    String round;
    String white;
    String black;
    String result;
    String whiteTitle;
    String blackTitle;
    String whiteElo;
    String blackElo;
    String whiteUSCF;
    String blackUSCF;
    String whiteNA;
    String blackNA;
    String whiteType;
    String blackType;
    String eventDate;
    String eventType;
    String eventCountry;
    String eventRounds;
    String eventSponsor;
    String section;
    String stage;
    String board;
    String opening;
    String variation;
    String subVariation;
    String eco;
    String nic;
    String time;
    String utcTime;
    String utcDate;
    String timeControl;
    String setUp;
    String fen;
    String termination;
    String annotator;
    String mode;
    String plyCount;
    String emaWhite;
    String emaBlack;
    String move;

    public Game () {
        this.event = null;
        this.site = null;
        this.date = null;
        this.round = null;
        this.white = null;
        this.black = null;
        this.result = null;
        this.whiteTitle = null;
        this.blackTitle = null;
        this.whiteElo = null;
        this.blackElo = null;
        this.whiteUSCF = null;
        this.blackUSCF = null;
        this.whiteNA = null;
        this.blackNA = null;
        this.whiteType = null;
        this.blackType = null;
        this.eventDate = null;
        this.eventType = null;
        this.eventCountry = null;
        this.eventRounds = null;
        this.eventSponsor = null;
        this.section = null;
        this.stage = null;
        this.board = null;
        this.opening = null;
        this.variation = null;
        this.subVariation = null;
        this.eco = null;
        this.nic = null;
        this.time = null;
        this.utcTime = null;
        this.utcDate = null;
        this.timeControl = null;
        this.setUp = null;
        this.fen = null;
        this.termination = null;
        this.annotator = null;
        this.mode = null;
        this.plyCount = null;
        this.emaWhite = null;
        this.emaBlack = null;
        this.move = null;
    }
}

class TablaGames extends LinkedHashMap {

  public void ShowContenido() {
    Enumeration en;
    System.out.println("");
    Iterator it = this.keySet().iterator();
    while (it.hasNext()) {
      String key = (String) it.next();
      Game gm = (Game) this.get(key);
      System.out.println ("Event .........: " + gm.event);
      System.out.println ("Site ..........: " + gm.site);
      System.out.println ("Date ..........: " + gm.date);
      System.out.println ("Round .........: " + gm.round);
      System.out.println ("White .........: " + gm.white);
      System.out.println ("Black .........: " + gm.black);
      System.out.println ("Result ........: " + gm.result);
      System.out.println ("WhiteTitle ....: " + gm.whiteTitle);
      System.out.println ("BlackTitle ....: " + gm.blackTitle);
      System.out.println ("WhiteElo ......: " + gm.whiteElo);
      System.out.println ("BlackElo ......: " + gm.blackElo);
      System.out.println ("whiteUSCF .....: " + gm.whiteUSCF);
      System.out.println ("BlackUSCF .....: " + gm.blackUSCF);
      System.out.println ("WhiteNA .......: " + gm.whiteNA);
      System.out.println ("BlackNA .......: " + gm.blackNA);
      System.out.println ("WhiteType .....: " + gm.whiteType);
      System.out.println ("BlackType .....: " + gm.blackType);
      System.out.println ("EventDate .....: " + gm.eventDate);
      System.out.println ("EventType .....: " + gm.eventType);
      System.out.println ("EventCountry ..: " + gm.eventCountry);
      System.out.println ("EventRounds ...: " + gm.eventRounds);
      System.out.println ("EventSponsor ..: " + gm.eventSponsor);
      System.out.println ("Section .......: " + gm.section);
      System.out.println ("Stage .........: " + gm.stage);
      System.out.println ("Board .........: " + gm.board);
      System.out.println ("Opening .......: " + gm.opening);
      System.out.println ("Variation .....: " + gm.variation);
      System.out.println ("SubVariation ..: " + gm.subVariation);
      System.out.println ("ECO ...........: " + gm.eco);
      System.out.println ("NIC ...........: " + gm.nic);
      System.out.println ("Time ..........: " + gm.time);
      System.out.println ("UTCTime .......: " + gm.utcTime);
      System.out.println ("UTCDate .......: " + gm.utcDate);
      System.out.println ("TimeControl ...: " + gm.timeControl);
      System.out.println ("SetUp .........: " + gm.setUp);
      System.out.println ("FEN ...........: " + gm.fen);
      System.out.println ("Termination ...: " + gm.termination);
      System.out.println ("Annotator .....: " + gm.annotator);
      System.out.println ("Mode ..........: " + gm.mode);
      System.out.println ("PlyCount ......: " + gm.plyCount);
      System.out.println ("EmaWhite ......: " + gm.emaWhite);
      System.out.println ("EmaBlack ......: " + gm.emaBlack);
      System.out.println ("Move ..........: " + gm.move);
      System.out.println ("");
    }
  }
}

%%

cadenastring = "\""[^\n"\""]*"\""
string = [a-zA-Z0-9_\-\.\:\/\!\;\,\=\$\#\{\{\?\'\%]+
move = [rnbqkpRNBQKPabcdefg]"x"?[abcdefgh][12345678]("+"|"#")?
digitos = [0-9]+
signo = "+"|"-"
entero = {signo}?{digitos}
nag = "$"{digitos}

%{
	public int getLine(){
		return yyline;
	}
%}

%state MOVE
%notunix
%full
%line
%char
%class lexGPAHS
%cup


%%

<YYINITIAL>[\t \r\n]* 	{ /* ignorar blancos */
                        }
<YYINITIAL>"["      { 
                    return new Symbol(sym.TK_CORCHETE_ABRIR);
                    }
<YYINITIAL>"]"      { 
                    return new Symbol(sym.TK_CORCHETE_CERRAR);
                    }
<YYINITIAL>"*"      {
                    yybegin (YYINITIAL);
                    return new Symbol(sym.TK_ASTERISCO);
                    }
<YYINITIAL>"1-0"    {
                    return new Symbol(sym.TK_WIN);
                    }
<YYINITIAL>"0-1"    {
                    return new Symbol(sym.TK_LOST);
                    }
<YYINITIAL>"1/2-1/2" {
                    return new Symbol(sym.TK_DRAW);
                    }
<YYINITIAL>{cadenastring}   { 
                            return new Symbol(sym.TK_CADENASTRING, new String(yytext().replaceAll("\"", "")));
                            }
<YYINITIAL>Event        { return new Symbol(sym.TK_EVENT);          }
<YYINITIAL>Site         { return new Symbol(sym.TK_SITE);           }
<YYINITIAL>Date         { return new Symbol(sym.TK_DATE);           }
<YYINITIAL>Round        { return new Symbol(sym.TK_ROUND);          }
<YYINITIAL>White        { return new Symbol(sym.TK_WHITE);          }
<YYINITIAL>Black        { return new Symbol(sym.TK_BLACK);          }
<YYINITIAL>Result       { return new Symbol(sym.TK_RESULT);         }
<YYINITIAL>WhiteTitle   { return new Symbol(sym.TK_WHITETITLE);     }
<YYINITIAL>BlackTitle   { return new Symbol(sym.TK_BLACKTITLE);     }
<YYINITIAL>WhiteElo     { return new Symbol(sym.TK_WHITEELO);       }
<YYINITIAL>BlackElo     { return new Symbol(sym.TK_BLACKELO);       }
<YYINITIAL>WhiteUSCF    { return new Symbol(sym.TK_WHITEUSCF);      }
<YYINITIAL>BlackUSCF    { return new Symbol(sym.TK_BLACKUSCF);      }
<YYINITIAL>WhiteNA      { return new Symbol(sym.TK_WHITENA);        }
<YYINITIAL>BlackNA      { return new Symbol(sym.TK_BLACKNA);        }
<YYINITIAL>WhiteType    { return new Symbol(sym.TK_WHITETYPE);      }
<YYINITIAL>BlackType    { return new Symbol(sym.TK_BLACKTYPE);      }
<YYINITIAL>EventDate    { return new Symbol(sym.TK_EVENTDATE);      }
<YYINITIAL>EventType    { return new Symbol(sym.TK_EVENTTYPE);      }
<YYINITIAL>EventCountry { return new Symbol(sym.TK_EVENTCOUNTRY);   }
<YYINITIAL>EventRounds  { return new Symbol(sym.TK_EVENTROUNDS);    }
<YYINITIAL>EventSponsor { return new Symbol(sym.TK_EVENTSPONSOR);   }
<YYINITIAL>Section      { return new Symbol(sym.TK_SECTION);        }
<YYINITIAL>Stage        { return new Symbol(sym.TK_STAGE);          }
<YYINITIAL>Board        { return new Symbol(sym.TK_BOARD);          }
<YYINITIAL>Opening      { return new Symbol(sym.TK_OPENING);        }
<YYINITIAL>Variation    { return new Symbol(sym.TK_VARIATION);      }
<YYINITIAL>SubVariation { return new Symbol(sym.TK_SUBVARIATION);   }
<YYINITIAL>ECO          { return new Symbol(sym.TK_ECO);            }
<YYINITIAL>NIC          { return new Symbol(sym.TK_NIC);            }
<YYINITIAL>Time         { return new Symbol(sym.TK_TIME);           }
<YYINITIAL>UTCTime      { return new Symbol(sym.TK_UTCTIME);        }
<YYINITIAL>UTCDate      { return new Symbol(sym.TK_UTCDATE);        }
<YYINITIAL>TimeControl  { return new Symbol(sym.TK_TIMECONTROL);    }
<YYINITIAL>SetUp        { return new Symbol(sym.TK_SETUP);          }
<YYINITIAL>FEN          { return new Symbol(sym.TK_FEN);            }
<YYINITIAL>Termination  { return new Symbol(sym.TK_TERMINATION);    }
<YYINITIAL>Annotator    { return new Symbol(sym.TK_ANNOTATOR);      }
<YYINITIAL>Mode         { return new Symbol(sym.TK_MODE);           }
<YYINITIAL>PlyCount     { return new Symbol(sym.TK_PLYCOUNT);       }
<YYINITIAL>EMAWhite     { return new Symbol(sym.TK_EMAWHITE);       }
<YYINITIAL>EMABlack     { return new Symbol(sym.TK_EMABLACK);       }

<YYINITIAL>{string} { yybegin (MOVE);
                    return new Symbol(sym.TK_STRING, new String(yytext())); }
<YYINITIAL>.        {
                    int line = yyline+1;
                    System.out.println("Error lexico en linea " + line + " - " + "Simbolo desconocido en YYINITIAL: " + yytext());
                    }

<MOVE>[\t \r\n]*    {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>"["           {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>"]"           {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>"("           {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>")"           {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>"{"           {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>"}"           {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>"1-0"         {
                    yybegin (YYINITIAL);
                    return new Symbol(sym.TK_WIN);
                    }
<MOVE>"0-1"         {
                    yybegin (YYINITIAL);
                    return new Symbol(sym.TK_LOST);
                    }
<MOVE>"1/2-1/2"     {
                    yybegin (YYINITIAL);
                    return new Symbol(sym.TK_DRAW);
                    }
<MOVE>"*"           {
                    yybegin (YYINITIAL);
                    return new Symbol(sym.TK_ASTERISCO);
                    }
<MOVE>{nag}         {
                    return new Symbol(sym.TK_NAG, new String(yytext()));
                    }
<MOVE>{entero}      {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>{move}        {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>{string}      {
                    return new Symbol(sym.TK_STRING, new String(yytext()));
                    }
<MOVE>.             {
                    int line = yyline+1;
                    System.out.println("Error lexico en linea " + line + " - " + "Simbolo desconocido en MOVE: " + yytext());
                    }